// -*- c++ -*-
// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!
#ifndef _LIBGDAMM_HANDLERSTRING_H
#define _LIBGDAMM_HANDLERSTRING_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

// -*- C++ -*- //

/* handlerstring.h
 *
 * Copyright 2006 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>
#include <libgdamm/datahandler.h>
#include <libgda/handlers/gda-handler-string.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdaHandlerString GdaHandlerString;
typedef struct _GdaHandlerStringClass GdaHandlerStringClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Gnome
{

namespace Gda
{ class HandlerString_Class; } // namespace Gda

} // namespace Gnome
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Gnome
{

namespace Gda
{

/** Default handler for strings.
 * 
 * @ingroup DataHandlers
 */

class HandlerString : public Glib::Object,
                      public DataHandler
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef HandlerString CppObjectType;
  typedef HandlerString_Class CppClassType;
  typedef GdaHandlerString BaseObjectType;
  typedef GdaHandlerStringClass BaseClassType;

  // noncopyable
  HandlerString(const HandlerString&) = delete;
  HandlerString& operator=(const HandlerString&) = delete;

private:  friend class HandlerString_Class;
  static CppClassType handlerstring_class_;

protected:
  explicit HandlerString(const Glib::ConstructParams& construct_params);
  explicit HandlerString(GdaHandlerString* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  HandlerString(HandlerString&& src) noexcept;
  HandlerString& operator=(HandlerString&& src) noexcept;

  virtual ~HandlerString() noexcept;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GdaHandlerString*       gobj()       { return reinterpret_cast<GdaHandlerString*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GdaHandlerString* gobj() const { return reinterpret_cast<GdaHandlerString*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GdaHandlerString* gobj_copy();

private:

  
protected:

 HandlerString();

public:
  
  static Glib::RefPtr<HandlerString> create();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gda
} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::Gda::HandlerString
   */
  Glib::RefPtr<Gnome::Gda::HandlerString> wrap(GdaHandlerString* object, bool take_copy = false);
}


#endif /* _LIBGDAMM_HANDLERSTRING_H */

